MODULE DistributedBank
(* originally from Lamports 9/91 TLA+ text, adapted to            *)
(* 2/92 and to Dortmund-Syntax: Mester, 9.7.92; Geikowski 24.5.93 *)

IMPORT BankInterface;

INCLUDE  ATMAction  AS atm;
         BankAction AS Bank(l,p) WITH ledger  <- l,
                                      pending <- p ;

TEMPORALS  (* Formula `Spec' is the actual specification. *)
  Spec  ==  :EE: ledger, pending
             ::
                LET ivbl  ==  (ledger, pending);
                    vbl   ==  (aToB, bToA, ledger, pending);
                IN /\ Init /\ Bank(ledger,pending).Init
                   /\ [] ( [ \/ (atm.N /\ ( ivbl' = ivbl )) 
                             \/ Bank(ledger,pending).N 
                           ]_(vbl)
                         )
                   /\ :A: A :in: ATM 
                       :: WF[vbl]( Bank(ledger,pending).NN(A) )
  ;

TEMPORAL THEOREMS  
  TypeCorrect  ==  Spec => [](TypeOK)
  ;

END
