TEMPORAL MODULE Lift

  IMPORT ElevatorDefs;

  PARAMETERS Light     : SET [ Floor -> OnOff ] STATE FCN;
             Location  : Floor                  STATE FCN;
             Direction : Directions             STATE FCN;

  ACTIONS
    MoveUp ==
      /\ :E: f :in: Interval(Location+1,TopFloor) :: Light[f] = "on"
      /\ \/ Direction = "GoingUp"
         \/ :A: f :in: Interval(1,Location-1) :: Light[f] = "off"
      /\ Location' = Location+1
      /\ Direction' = "GoingUp"
      /\ (Light[Location+1])' = "off"
      /\ :A: i :in: Floor :: i # Location+1 => Light[i] = Light[i]'
    ;

    MoveDown ==
      /\ :E: f :in: Interval(1,Location-1) :: Light[f] = "on"
      /\ \/ Direction = "GoingDown"
         \/ :A: f :in: Interval(Location+1,TopFloor) :: Light[f] = "off"
      /\ Location' = Location-1
      /\ Direction' = "GoingDown"
      /\ Light[Location-1]' = "off"
      /\ :A: i :in: Floor :: i # Location-1 => Light[i] = Light[i]'
    ;

END Lift
